<?php
# 2005 aug 2

#drop table if exists loginpermission;
#create table loginpermission
#(
#  id int primary key not null auto_increment,
#  lastinsert datetime default "0000-00-00 00:00:00",
#  lastupdate datetime default "0000-00-00 00:00:00",
#  username varchar(64) not null,
#  permission varchar(64) not null,
#  unique key userpermkey (username, permission)
#);

include_once("usermenu.inc");

class orderadmin extends usermenu
{
  function orderadmin
  (
  )
  {
    usermenu::usermenu();

    $this->label["itemname"] = sprintf("%s", "Item Name");
    $this->label["quantity"] = sprintf("%s", "Quantity");
    $this->label["refresh"] = sprintf("%s", "Refresh");
    $this->label["confirm"] = sprintf("%s", "Confirm");
    $this->label["totalcost"] = sprintf("%s", "Total Cost");
    $this->label["orderid"] = sprintf("%s", "Order #");

    return;
  }

  function gethiddentags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);

    $str = "";
    $str .= sprintf("%s", usermenu::gethiddentags());
    $hiddenarray =
      array
      (
        "objid" => sprintf("%s", "${objid}"),
      );
    reset($hiddenarray);
    while(list($hiddenkey,$hiddenvalue) = each($hiddenarray))
    {
      $str .= <<<_STR_
<input type="hidden" name="${hiddenkey}" value="${hiddenvalue}">
_STR_;
    }
    return $str;
  }

  function getscripttags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);

    $str = "";
    $str .= usermenu::getscripttags();
    $str .= <<<_STR_
<script>
var itemarray = new Array();
function setrefresh
(
)
{
  var currform = document.forms[0];
  var counter = 0;
  var itemnames = currform.itemname.options;
  var itemid = 0;
  var str = '';
  var totalcost = 0;
  var matcharray = new Array();

  itemid = (new Number(itemnames[itemnames.selectedIndex].value)).valueOf();
  itemarray[itemid] = (new Number(currform.quantity.value)).valueOf();

  for (counter=0;counter<itemnames.length;counter++)
  {
    if (itemnames[counter].value == null)
    {
      continue;
    }
    if (itemnames[counter].value <= 0)
    {
      continue;
    }
    if (itemnames[counter].text == '')
    {
      continue;
    }
    itemid = (new Number(itemnames[counter].value)).valueOf();
    if (itemarray[itemid] == null)
    {
      continue;
    }
    if (itemarray[itemid] <= 0)
    {
      continue;
    }
    str = str.concat(itemnames[counter].text + '*' + itemarray[itemid] + '\\r\\n');
    matcharray = (itemnames[counter].text).match(new RegExp('^(\\\\d+)[\\\\.] (.+) \\\\(\\\\$(.+)\\\\)$'));
    if (matcharray != null)
    {
      totalcost += (new Number(matcharray[3])).valueOf() * itemarray[itemid];
    }
  }
  document.getElementById('dividtotalcost').innerHTML = '$' + totalcost;
  currform.orderlist.value = str;
  return;
}
function setconfirm
(
)
{
  var elem = null;
  var counter = 0;
  var currform = document.forms[0];
  var itemnames = currform.itemname.options;
  var matcharray = new Array();
  var itemid = 0;

  for (counter=0;counter<itemnames.length;counter++)
  {
    if (itemnames[counter] == null)
    {
      continue;
    }
    if (itemnames[counter].text == '')
    {
      continue;
    }
    matcharray = (itemnames[counter].text).match(new RegExp('^(\\\\d+)[\\\\.] (.+) \\\\(\\\\$(.+)\\\\)$'));
    if (matcharray == null)
    {
      continue;
    }

    itemid = (new Number(itemnames[counter].value)).valueOf();
    if (itemarray[itemid] == null)
    {
      continue;
    }
    if (itemarray[itemid] <= 0)
    {
      continue;
    }

    elem = document.createElement('input');
    elem.type = 'hidden';
    elem.name = 'itemarray[' + counter + '][itemname]';
    elem.value = '' + matcharray[2];
    document.forms[0].appendChild(elem);

    elem = document.createElement('input');
    elem.type = 'hidden';
    elem.name = 'itemarray[' + counter + '][quantity]';
    elem.value = '' + itemarray[itemid];
    document.forms[0].appendChild(elem);
  }
  setobjfunc('${obj}', 'modify');
  return;
}
</script>
_STR_;
    return $str;
  }

  function getpaneltags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);

    $itemlisttags = $this->getitemlisttags();

    $str = "";
    $str .= <<<_STR_
<table width="800" cellspacing="0" cellpadding="0" border="1">
<tr>
<td valign="top" class="formtext">
<b>${labelorderid} : [ ${objid} ]</b>

<div align="left">
<table cellspacing="10">
<tr>
<td valign="top"><b>${labeltotalcost}:</b></td>
<td valign="top"><div id="dividtotalcost"></div></td>
<td valign="top"><input type="button" class="globalbutton" value="${labelconfirm}" onclick="javascript:setconfirm();"></td>
</tr>
</table>
</div>

${itemlisttags}
</td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getitemlisttags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);

    unset($itemnames);
    $options = "";
    $sql = sprintf("select * from itemlist;",
      mysql_escape_string(${orderid}));
    $db = new dbmysql();
    $db->setquery($sql);
    reset($db->result);
    while(list($dbkey,$dbvalue) = each($db->result))
    {
      $itemnames["".$dbvalue["itemlist.itemname"]] =
        sprintf("%d", $dbvalue["itemlist.id"]);
      $options .= sprintf("<option value=\"%d\">%d. %s ($%0.2f)</option>\n",
        $dbvalue["itemlist.id"],
        $dbvalue["itemlist.id"],
        $dbvalue["itemlist.itemname"],
        $dbvalue["itemlist.unitprice"]);
    }

    $items = "";
    $sql = sprintf("select * from itemorder where orderid=\"%s\";",
      mysql_escape_string(${objid}));
    $db = new dbmysql();
    $db->setquery($sql);
    reset($db->result);
    while(list($dbkey,$dbvalue) = each($db->result))
    {
      $itemid = $itemnames["".$dbvalue["itemorder.itemname"]];
      $items .= sprintf("itemarray[%d]=%d;\n",
        $itemid,
        $dbvalue["itemorder.quantity"]);
    }

    $str = "";
    $str .= <<<_STR_
<table>
<tr bgcolor="#cccccc">
<td valign="top">${labelitemname}</td>
<td valign="top">${labelquantity}</td>
<td valign="top">&nbsp;</td>
</tr>
<tr>
<td valign="top">
<select class="formtext" name="itemname">
<option value=""></option>
${options}
</select>
</td>
<td valign="top">
<input type="text" class="formtext" name="quantity" onchange="javascript:this.value=(new Number(this.value)).valueOf();">
</td>
<td valign="top"><input type="button" class="globalbutton" value="${labelrefresh}" onclick="javascript:setrefresh();"></td>
</tr>
<tr>
<td valign="top" colspan="3">
<textarea name="orderlist" cols="80" rows="20"></textarea>
</td>
</tr>
</table>
<script>
${items}
setrefresh();
</script>
_STR_;
    return $str;
  }

  function settransaction
  (
  )
  {
    usermenu::settransaction();

    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));

    $datetimenow = date("Y-m-d H:i:s");

    if ($objfunc == "modify")
    {
      $sql = sprintf("select lastinsert, usernameinsert from itemorder where orderid=\"%s\";",
        mysql_escape_string(${objid}));
      $db = new dbmysql();
      $db->setquery($sql);
      $lastinsert = $db->result[0]["itemorder.lastinsert"];
      $usernameinsert = $db->result[0]["itemorder.usernameinsert"];

        unset($recordarray);
        $fields = $this->commontool->getdbtablefields("itemorder");
        reset($fields);
        while(list($fieldkey,$fieldvalue) = each($fields))
        {
          $recordarray[sprintf("%s", $fieldkey)] = sprintf("\"\"");
        }
        $recordarray["id"] = sprintf("null", mysql_escape_string($maxid));
        $recordarray["lastinsert"] = sprintf("\"%s\"", mysql_escape_string($lastinsert));
        $recordarray["lastupdate"] = sprintf("\"%s\"", mysql_escape_string($datetimenow));
        $recordarray["usernameinsert"] = sprintf("\"%s\"", mysql_escape_string($usernameinsert));
        $recordarray["usernameupdate"] = sprintf("\"%s\"", mysql_escape_string($loginusername));
        $recordarray["orderid"] = sprintf("\"%s\"", mysql_escape_string($objid));

      $sql = sprintf("delete from itemorder where orderid=\"%s\";",
        mysql_escape_string(${objid}));
      $db = new dbmysql();
      $db->setquery($sql);

      reset($itemarray);
      while(list($itemkey,$itemvalue) = each($itemarray))
      {
        $recordarray["itemname"] = sprintf("\"%s\"", mysql_escape_string($itemvalue["itemname"]));
        $recordarray["quantity"] = sprintf("\"%s\"", mysql_escape_string($itemvalue["quantity"]));
        $sql = sprintf("insert into itemorder (%s) values (%s);",
          implode(",", array_keys($recordarray)),
          implode(",", array_values($recordarray)));
        $db = new dbmysql();
        $db->setquery($sql);
      }
    }

    return;
  }
}
?>
