<?php
# 2005 aug 2

include_once("orderadmin.inc");

class orderlist extends orderadmin
{
  function orderlist
  (
  )
  {
    orderadmin::orderadmin();

    $this->label["searchyear"] = "Year";
    $this->label["searchmonth"] = "Month";
    $this->label["searchday"] = "Day";
    $this->label["search"] = "Search";

    $this->label["orderid"] = "Order #";
    $this->label["lastinsert"] = "Insert Timestamp";
    $this->label["usernameinsert"] = "Inserted By";
    $this->label["lastupdate"] = "Update Timestamp";
    $this->label["usernameupdate"] = "Updated By";

    return;
  }

  function gethiddentags
  (
  )
  {
    $str = "";
    $str .= sprintf("%s", usermenu::gethiddentags());
    $hiddenarray =
      array
      (
        "objid" => sprintf("%s", ""),
      );
    reset($hiddenarray);
    while(list($hiddenkey,$hiddenvalue) = each($hiddenarray))
    {
      $str .= <<<_STR_
<input type="hidden" name="${hiddenkey}" value="${hiddenvalue}">
_STR_;
    }
    return $str;
  }

  function getscripttags
  (
  )
  {
    $str = "";
    $str .= usermenu::getscripttags();
    $str .= <<<_STR_
<script>
function setobjid
(
  objid
)
{
  document.forms[0].objid.value = objid;
  setobjfunc('orderadmin', '');
  return;
}
function sethighlight
(
  obj,
  status
)
{
  if (status == 'on')
  {
    obj.style.backgroundColor='#e3e3e3';
  }
  if (status == 'off')
  {
    obj.style.backgroundColor='#ffffff';
  }
  return;
}
</script>
_STR_;
    return $str;
  }

  function getpaneltags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);

    $searchtags = $this->getsearchtags();
    $listtags = $this->getlisttags();

    $str = "";
    $str .= <<<_STR_
<table width="800" cellspacing="0" cellpadding="0" border="1">
<tr>
<td valign="top" class="formtext">
${searchtags}
</td>
</tr>
<tr>
<td valign="top" colspan="3">
${listtags}
</td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getlisttags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);

    $searchyear = sprintf("%04d", $searchyear);
    if ($searchyear == "0000")
    {
      $searchyear = "%";
    }
    $searchmonth = sprintf("%02d", $searchmonth);
    if ($searchmonth == "00")
    {
      $searchmonth = "%";
    }
    $searchday = sprintf("%02d", $searchday);
    if ($searchday == "00")
    {
      $searchday = "%";
    }

    $cells = "";
    unset($condarray);
    $condarray[] = sprintf("lastupdate like \"%s\"",
      mysql_escape_string(sprintf("%s-%s-%s %%", $searchyear, $searchmonth, $searchday)));
    $sql = sprintf("select * from itemorder where %s group by orderid order by lastinsert desc;",
      implode(",", $condarray));
    $db = new dbmysql();
    $db->setquery($sql);
    reset($db->result);
    while(list($dbkey,$dbvalue) = each($db->result))
    {
      $orderid = $dbvalue["itemorder.orderid"];
      $lastinsert = $dbvalue["itemorder.lastinsert"];
      $usernameinsert = $dbvalue["itemorder.usernameinsert"];
      $lastupdate = $dbvalue["itemorder.lastupdate"];
      $usernameupdate = $dbvalue["itemorder.usernameupdate"];
      $cells .= <<<_STR_
<tr onmouseover="javascript:sethighlight(this, 'on');" onmouseout="javascript:sethighlight(this, 'off');">
<td valign="top"><a class="globallink" href="javascript:setobjid('${orderid}');">${orderid}</a></td>
<td valign="top">${lastinsert}</td>
<td valign="top">${usernameinsert}</td>
<td valign="top">${lastupdate}</td>
<td valign="top">${usernameupdate}</td>
</tr>
_STR_;
    }

    $str = "";
    $str .= <<<_STR_
<table width="100%">
<tr bgcolor="#cccccc">
<td valign="top">${labelorderid}</td>
<td valign="top">${labellastinsert}</td>
<td valign="top">${labelusernameinsert}</td>
<td valign="top">${labellastupdate}</td>
<td valign="top">${labelusernameupdate}</td>
</tr>
${cells}
</table>
_STR_;

    return $str;
  }

  function getsearchtags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);

    if (($searchyear == "") &&
        ($searchmonth == "") &&
        ($searchday == ""))
    {
      $tokens = preg_split("/-/", trim(date("Y-m-d")));
      $searchyear = $tokens[0];
      $searchmonth = $tokens[1];
      $searchday = $tokens[2];
    }

    $str = "";
    $str .= <<<_STR_
<table width="100%">
<tr>
<td valign="top">${labelsearchyear}:<input type="text" name="searchyear" value="${searchyear}"></td>
<td valign="top">${labelsearchmonth}:<input type="text" name="searchmonth" value="${searchmonth}"></td>
<td valign="top">${labelsearchday}:<input type="text" name="searchday" value="${searchday}"></td>
<td valign="top"><input type="button" class="globalbutton" value="${labelsearch}" onclick="javascript:setobjfunc('${obj}','');"></td>
</tr>
</table>
_STR_;
    return $str;
  }
}
?>
